HDU 1728 逃离迷宫

真特么蛋疼 一开始我也是把这道题当成常规的 BFS 求最短路径 来写 WA了3发 百思不得其姐 bug怎么找都找不出来 无奈看了一下题解才恍然大悟

这么说吧 题目要求的是 从一个点到另一个点的最小拐弯数

假如说是常规的BFS 从一点到另一点 只能保证路径最短 拐弯数的多少和路径长短是毫无联系的

所以我们每次查找四个方向的时候 直接把一整条直线的grid全都压进队列 因为他们的拐弯数相同 优先级相同

AC Code 感觉时间略长 有待优化 只能助于理解用

#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;
int row,col,limit;
int st_x,st_y,en_x,en_y;
char mat[110][110];
bool vis[110][110];
int dx[]= {-1,0,1,0};
int dy[]= {0,-1,0,1};

struct node
{
    int x,y;
    int step;
    node(int _x,int _y,int _step):x(_x),y(_y),step(_step) {}
};

bool judge(int a,int b)
{
    return a>0&&a<=row&&b>0&&b<=col&&mat[a][b]=='.';
}

void bfs()
{
    queue<node> que;
    que.push(node(st_x,st_y,-2));
    vis[st_x][st_y]=true;
    while(!que.empty())
    {
        node temp=que.front();
        que.pop();
        int x=temp.x,y=temp.y;
        int step=temp.step+1;
        //printf("%d %d %d\n",x,y,step);
        if(x==en_x&&y==en_y&&step<=limit)
        {
            printf("yes\n");
            return ;
        }
        for(int i=0; i<4; i++)
        {
            int xx=x+dx[i];
            int yy=y+dy[i];
            while(judge(xx,yy))
            {
                if(!vis[xx][yy])
                {
                    vis[xx][yy]=true;
                    que.push(node(xx,yy,step));
                }
                xx+=dx[i];
                yy+=dy[i];
            }
        }
    }
    printf("no\n");
    return ;
}


int main()
{
    int test;
    scanf("%d",&test);
    while(test--)
    {
        scanf("%d%d",&row,&col);
        getchar();
        for(int i=1; i<=row; i++)
        {
            for(int j=1; j<=col; j++)
                scanf("%c",&mat[i][j]);
            getchar();
        }
        scanf("%d%d%d%d%d",&limit,&st_y,&st_x,&en_y,&en_x);
        memset(vis,false,sizeof vis);
        bfs();
    }
    return 0;
}